package com.tangcs.samples.testjpa;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.NamedQuery;

@Entity
@NamedQuery(name = "findAllBooks", query="select b from Book b")
public class Book {
  @Id @GeneratedValue
  private Long id;
  @Column(nullable = false)
  private String title;
  private Float price;
  @Column(length = 2000)
  private String description;
  private String isbn;
  private Integer nbOfPage;
  private Boolean illustrations;
  
  public Book() {}
  
  public Book(String title, Float price, String description, 
      String isbn, Integer nbOfPage, Boolean illustrations) {
    this.title = title;
    this.price = price;
    this.description = description;
    this.isbn = isbn;
    this.nbOfPage = nbOfPage;
    this.illustrations = illustrations;
  }
  
  public Long getId() { return id; }
  public String getTitle() { return title; }
  public Float getPrice() { return price; }
  public String getDescription() { return description; }
  public String getIsbn() { return isbn; }
  public Integer getNbOfPage() { return nbOfPage; }
  public Boolean getIllustrations() { return illustrations; }
  
  public void setId(Long id) { this.id = id; }
  public void setTitle(String title) { this.title = title; }
  public void setPrice(Float price) { this.price = price; }
  public void setDescription(String description) { this.description = description; }
  public void setIsbn(String isbn) { this.isbn = isbn; }
  public void setNbOfPage(Integer nbOfPage) { this.nbOfPage = nbOfPage; }
  public void setIllustrations(Boolean illustrations) { this.illustrations = illustrations; }
  
  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    
    sb.append("Book"); 
    sb.append("{id=").append(id);
    sb.append(", title='").append(title).append("'");
    sb.append(", price='").append(price).append("'");
    sb.append(", description='").append(description).append("'");
    sb.append(", isbn='").append(isbn).append("'");
    sb.append(", nbOfPage='").append(nbOfPage).append("'");
    sb.append(", illustrations='").append(illustrations).append("'");
    sb.append("}");
    
    return sb.toString();
  }
}
