package com.tangcs.samples.testjpa;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

public class Main {

  public static void main(String[] args) {
    Book b = new Book();
    b.setTitle("Beginning Java EE 6");
    b.setPrice(12.5f);
    b.setDescription("An introduction to Java EE 6");
    b.setIsbn("1-222222-8");
    b.setNbOfPage(522);
    b.setIllustrations(false);
    
    EntityManagerFactory factory = null;
    EntityManager manager = null; 
    EntityTransaction trans = null;
    try {
      factory = Persistence.createEntityManagerFactory("WarrenPU");
      manager = factory.createEntityManager();
      
      trans = manager.getTransaction();
      trans.begin();
      manager.persist(b);    
      trans.commit();
    } catch(Throwable ex) {
      System.out.println(ex.toString());
      if(trans != null) {
        trans.rollback();
      }
    } finally {
      if(manager != null) {
        manager.close();
      }
      if(factory != null) {
        factory.close();
      }
    }
  }

}
