package com.tangcs.samples.testjpa;

import static org.junit.Assert.*;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

public class BookTest {
  private static EntityManagerFactory factory;
  private static EntityManager manager;
  private EntityTransaction trans;

  @BeforeClass public static void beforeClass() {
    factory = Persistence.createEntityManagerFactory("WarrenPU");
    manager = factory.createEntityManager();
  }
  
  @AfterClass public static void afterClass() {
    if(manager != null) {
      manager.close();
    }
    if(factory != null) {
      factory.close();
    }
  }

  @Before public void before() {
    trans = manager.getTransaction();
  }
  
  @Test public void createBook() {
    //given
    Book b = new Book();
    b.setTitle("Beginner Java EE 6");
    b.setPrice(12.5f);
    b.setDescription("An introduction to Java EE 6");
    b.setIsbn("1-222222-8");
    b.setNbOfPage(522);
    b.setIllustrations(false);
    
    //when
    trans.begin();
    manager.persist(b);
    trans.commit();
    
    //then
    assertNotNull(b.getId());
    List<Book> books = manager.createNamedQuery("findAllBooks").getResultList();
    assertNotNull(books);
  }
}
